#Boa:Frame:wxFrame1

from wxPython.wx import *
from os import *
from numarray import *
from string import *
from fileinput import *
import time
from threading import *
#import win32gui
#from matplotlib.matlab import *
import wxDialog1
import wxDialog2
import wxDialog3

#Global Constants
SAMPLE_SIZE     = 4
FALSE           = 0
TRUE            = 1

#Upper and Lower Control limit Variables for Sample Size = 10, see SAMPLE_SIZE above
#values were obtained from Appendix Table A.5 page 397 from "Understanding 
#Statistical Process Control
A3 = 0.975
B3 = 0.284
B4 = 1.716

#number of samples outside control limits
CONDITION_ZERO  = 8
CONDITION_ONE   = 4
CONDITION_TWO   = 2
CONDITION_THREE = 1

#time delay (s) between checking for new data in pfile
const_checkTime = 3

#maximum flow rate (gpm) for SeaMetrics' 1" precision bench
MaxFlow         = 15 

#file path names
directory               = getcwd()
const_configFilePath    = directory+"\\"+"config.py"            
const_pfilePath         = directory+"\\"+"records0.py"

#length of meter names
const_characterLength   = 20

# Define notification event for thread completion

EVT_RESULT_ID = wxNewId()

def EVT_RESULT(win, func):
    win.Connect(-1, -1, EVT_RESULT_ID, func)

#calculate the average of an array
def average(array):
    avg = 0
    for i in range(0,len(array)):
        avg = avg + array[i]
    avg = avg/len(array)
    
    return avg

def Reload(self, pfile):
    #variables
    meterID  = 0
    err      = FALSE
    myMeter  = []
    
    #update meter info from config file
    (const_mType,const_mIndexForward,
    const_mIndexReverse,UCLK,
    LCLK,UCLS,LCLS) = FillMeterTypeDictionary(self, const_configFilePath)
            
    #create class for each meter type
    for i in range(0,len(const_mType)+1):
        myMeter.append([])
        myMeter[i] = meter()
        

    #open p-file for reading
    fileHandle     = file(pfile, "r")

    #Each line of the p-file contains either k-factor, flow rate, or meter
    #type information. search each line for the type of information and append it
    #to the correct meter 

    line = fileHandle.readline()

    while line != '' and err == FALSE:
        #separate the line by commas to a list
        line = line.split(',')

        #remove all quotations
        for i in range(0,len(line)):
            line[i] = line[i].replace('"','')

        #get meter ID
        if line[0] == 'Meter Number' and line[3] == "1":
            try:
                meterID = const_mIndexForward[atoi(line[2])]

                #get time; the time is in (ms), convert to (s)
                myMeter[meterID].time.append((atof(line[4])/1000.0))
    
                #get date
                myMeter[meterID].date.append((line[1][0:10].replace(' ','')))
            
            except:
                dlg = wxMessageDialog(self, """The Configuration File has variable ID's that are different 
                than those in the Data File.""",
                  'Caption', wxOK | wxICON_INFORMATION)
                try:
                    dlg.ShowModal()
                finally:
                    dlg.Destroy()
                break

        #get kfactor
        elif line[0] == 'kfactor' and line[3] == "1" and meterID != 0:
            try:
                myMeter[meterID].k.append((atof(line[2])/100.0))
            except:
                dlg = wxMessageDialog(self, """Config file may have more or less 
                than the number of meters in the data file.""",
                  'Caption', wxOK | wxICON_INFORMATION)
                try:
                    dlg.ShowModal()
                finally:
                    dlg.Destroy()
                break
            
        #get flow rate
        elif line[0] == 'velocity' and line[3] == "1" and meterID != 0:
            try:
                myMeter[meterID].q.append((atof(line[2])/1000.0))
            except:
                dlg = wxMessageDialog(self, """Config file may have more or less 
                than the number of meters in the data file.""",
                  'Caption', wxOK | wxICON_INFORMATION)
                try:
                    dlg.ShowModal()
                finally:
                    dlg.Destroy()
                break
            
        elif line[0] == 'testserialno' and line[3] == "1" and meterID != 0:
            try:
                myMeter[meterID].serialNum.append((atof(line[2])/1000.0))
            except:
                dlg = wxMessageDialog(self, """Config file may have more or less 
                than the number of meters in the data file.""",
                  'Caption', wxOK | wxICON_INFORMATION)
                try:
                    dlg.ShowModal()
                finally:
                    dlg.Destroy()
                break
             
        #read the next line
        line = fileHandle.readline()
    
    #sort k-factor data into groups of sample size equal to SAMPLE_SIZE
    for i in range(1,len(const_mType)+1):    
        myMeter[i].k_copy   = resize(array(myMeter[i].k), 
        (array(myMeter[i].k).shape[0]/SAMPLE_SIZE, SAMPLE_SIZE))

    #calculate k-factor statistics for each group
    #xBar and stdev   
    for i in range(1,len(const_mType)+1):
        for j in range(0,len(myMeter[i].k_copy)):
            myMeter[i].kBar.append(average(myMeter[i].k_copy[j]))
            
            kSum = 0
            for k in range(0,len(myMeter[i].k_copy[j])): 
                kSum = kSum + (myMeter[i].k_copy[j][k]-myMeter[i].kBar[j])**2
            myMeter[i].stdev.append((kSum/(len(myMeter[i].k_copy[j])-1))**0.5)
            
        #calculate average of average K-factor and average of standard deviation
        try:
            myMeter[i].kDoubleBar   = average(myMeter[i].kBar)
            myMeter[i].sBar         = average(myMeter[i].stdev)
        except:
            myMeter[i].kDoubleBar   = 0
            myMeter[i].sBar         = 0

    #close the filehandle
    fileHandle.close()
    
    #return the new data
    return myMeter





def CheckFile(self, const_pfilePath, fileSize):

    if int(stat(const_pfilePath)[6]) > fileSize:
        #update the file size
        self.fileSize = int(stat(const_pfilePath)[6])

        return TRUE

    else:
        return FALSE

#stat is an array of sample values for a particular meter (ie, myMeter[i].kbar)
#ref is the central control (ie, K double bar, or S bar)
#sign is the the upper or lower half of central control limit
#length is the length of samples outside of boundaries
def TestControl(self, ref, stat, sigma, sign, length):
    test      = zeros(length) - 1
    badMeters = FALSE

    if sign == 'Positive':
        for j in range(0,len(stat)):
            if stat[j] > ref+sigma:
                for i in range(0,length-1):
                    test[i] = test[i+1]
                
                test[length-1] = j                
                if test[length-1] == (test[0]+length-1) and test[0] != -1:
                    badMeters = TRUE
                    break
                
    elif sign == 'Negative':
        for j in range(0,len(stat)):
            if stat[j] < ref-sigma:
                for i in range(0,length-1):
                    test[i] = test[i+1]
                
                test[length-1] = j              
                if test[length-1] == (test[0]+length-1) and test[0] != -1:
                    badMeters = TRUE
                    break               
                
    return badMeters               

def CleanString(string):
    string = string.replace('"','')
    string = string.replace('\t','')
    string = string.replace(' ','')
    string = string.replace('\n','')
    return string

#make string length long
def CleanLength(string, length):
    #if length is less than length add spaces
    if len(string) < length:
        adjust = length - len(string)
        for j in range(0,adjust):
            string = string + " "
    
    #if string is greater than length subract characters
    elif len(string) > length:
        string = string[0:length]
    
    return string
            
def FillMeterTypeDictionary(self,const_configFilePath):
    #variables
    count               = 1
    const_mType         = []
    const_mIndexForward = []
    const_mIndexReverse = []
    #full scale variables
    UCLK              = []
    LCLK              = []
    UCLS              = []
    LCLS              = []
      
    fileHandle          = file(const_configFilePath, "r")

    #Each line of the p-file contains either k-factor, flow rate, or meter
    #type information. search each line for the type of information and append it
    #to the correct meter 
    line = fileHandle.readline()
    
    #remove all quotations and spaces and returns and tabs
    line = CleanString(line)
    while line != '#END':      
        #separate the line by commas
        line = line.split(',')

        #get meter ID
        if line[0] == 'TAG':
            #build dictionary
            #line[2] = CleanLength(line[2], const_characterLength)
            const_mType.append((atoi(line[1]),line[2]))
            const_mIndexForward.append((atoi(line[1]),count))
            const_mIndexReverse.append((count,atoi(line[1])))
            
            UCLK.append((atoi(line[1]),atof(line[4])))
            LCLK.append((atoi(line[1]),atof(line[3])))
            UCLS.append((atoi(line[1]),atof(line[6])))
            LCLS.append((atoi(line[1]),atof(line[5])))
            
            count = count+1
        
        #read the next line
        line = fileHandle.readline()
        
        #remove all quotations and spaces and returns and tabs
        line = CleanString(line)
            
    #cast list of tuples to dictionary
    const_mType         = dict(const_mType)
    const_mIndexForward = dict(const_mIndexForward)
    const_mIndexReverse = dict(const_mIndexReverse)
    UCLK                = dict(UCLK)
    LCLK                = dict(LCLK)
    UCLS                = dict(UCLS)
    LCLS                = dict(LCLS)
    
    #close the filehandle
    fileHandle.close()
    
    #return data
    return const_mType,const_mIndexForward,const_mIndexReverse,UCLK,LCLK,UCLS,LCLS

    
#check if system is in control or out of control
def CheckProcess(self, myMeter):
    #variables    
    #badMeters stores the type of meter that is out of control
    badMeters   = []
    
    (const_mType,const_mIndexForward,
    const_mIndexReverse,UCLK,
    LCLK,UCLS,LCLS) = FillMeterTypeDictionary(self, const_configFilePath)
    
    #compute statistics    
    for i in range(1,len(const_mType)+1):
        sigmaK      = (1.0/3.0)*(UCLK[const_mIndexReverse[i]]-LCLK[const_mIndexReverse[i]])
        sigmaS      = (1.0/3.0)*(UCLS[const_mIndexReverse[i]]-LCLS[const_mIndexReverse[i]])
        KdoubleBar  = 0.5*(UCLK[const_mIndexReverse[i]]+LCLK[const_mIndexReverse[i]])
        Sbar        = 0.5*(UCLS[const_mIndexReverse[i]]+LCLS[const_mIndexReverse[i]])
        #if any point is outside three sigma
        string = 'CONDITION 3'
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (3*sigmaK), 'Positive', CONDITION_THREE)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (3*sigmaK), 'Negative', CONDITION_THREE)
        if data != FALSE:
            badMeters.append((i,string))   
        data = TestControl(self, Sbar, myMeter[i].stdev, (3*sigmaS), 'Positive', CONDITION_THREE)
        if data != FALSE:
            badMeters.append((i,string))  
        data = TestControl(self, Sbar, myMeter[i].stdev, (3*sigmaS), 'Negative', CONDITION_THREE)
        if data != FALSE:
            badMeters.append((i,string))    
        #if two consecutive points on one side are outside 2 sigma 
        string = 'CONDITION 2'
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (2*sigmaK), 'Positive', CONDITION_TWO)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (2*sigmaK), 'Negative', CONDITION_TWO)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, Sbar, myMeter[i].stdev, (2*sigmaS), 'Positive', CONDITION_TWO)
        if data != FALSE:
            badMeters.append((i,string))
        data = TestControl(self, Sbar, myMeter[i].stdev, (2*sigmaS), 'Negative', CONDITION_TWO)
        if data != FALSE:
            badMeters.append((i,string))  
        #if four consecutive points on one side are outside 1 sigma  
        string = 'CONDITION 1'
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (1*sigmaK), 'Positive', CONDITION_ONE)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, (1*sigmaK), 'Negative', CONDITION_ONE)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, Sbar, myMeter[i].stdev, (1*sigmaS), 'Positive', CONDITION_ONE)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, Sbar, myMeter[i].stdev, (1*sigmaS), 'Negative', CONDITION_ONE)
        if data != FALSE:
            badMeters.append((i,string)) 
        #if eight consecutive points on one side
        string = 'CONDITION 0'
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, 0, 'Positive', CONDITION_ZERO)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, KdoubleBar, myMeter[i].kBar, 0, 'Negative', CONDITION_ZERO)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, Sbar, myMeter[i].stdev, 0, 'Positive', CONDITION_ZERO)
        if data != FALSE:
            badMeters.append((i,string)) 
        data = TestControl(self, Sbar, myMeter[i].stdev, 0, 'Negative', CONDITION_ZERO)
        if data != FALSE:
            badMeters.append((i,string)) 
    return badMeters

class meter:

    def __init__(self):
        self.k          = []
        self.q          = []
        self.k_copy     = []
        self.q_copy     = []
        self.time       = []
        self.date       = []
        self.kDoubleBar = 0  #average of average k-factor used to set control limits in dialog 1 only
        self.sBar       = 0  #average of standard deviations sed to set control limits in dialog 1 only
        self.stdev      = [] #standard deviation of k-factor
        self.kBar       = [] #average of k-factor
        self.serialNum  = []
        
class ResultEvent(wxPyEvent):
    """Simple event to carry arbitrary result data"""
    
    def __init__(self, data):
        wxPyEvent.__init__(self)
        self.SetEventType(EVT_RESULT_ID)
        self.data = data

   
# Thread class that executes processing

class WorkerThread(Thread):

    def __init__(self, notify_window):
        Thread.__init__(self)
        self._notify_window = notify_window
        self._want_abort = 0

        # This starts the thread running on creation, but you could
        # also make the GUI thread responsible for calling this
        self.start()



    def run(self):

        # This is the code executing in the new thread. Simulation of
        # a long process (well, 10s here) as a simple loop - you will
        # need to structure your processing so that you periodically
        # peek at the abort variable

        if self._want_abort != 1:
            #indicate monitor is sleeping
            wxPostEvent(self._notify_window,ResultEvent(1))

            #start a timer object
            time.sleep(const_checkTime)
            
        #this is necessary because the event ID may change to 3
        #but this sleep may still be functioning under the above 
        #if statement. For this case the Event ID will then change
        #to 2 and the thread will go continuously 
        if self._want_abort != 1:
            #indicate monitor is not sleeping
            wxPostEvent(self._notify_window,ResultEvent(2))

        else:
            # Use a result of None to acknowledge the abort
            wxPostEvent(self._notify_window,ResultEvent(None))
            return
        

    def abort(self):
        # Method for use by main thread to signal an abort
        self._want_abort = 1
    
def create(parent):
    return wxFrame1(parent)

[wxID_WXFRAME1, wxID_WXFRAME1CANCEL, wxID_WXFRAME1STATICBOX1, 
 wxID_WXFRAME1STATICBOX2, wxID_WXFRAME1STOP, wxID_WXFRAME1TEXTCTRL1, 
 wxID_WXFRAME1TEXTCTRL2, wxID_WXFRAME1TEXTFIELD, 
] = map(lambda _init_ctrls: wxNewId(), range(8))

[wxID_WXFRAME1MENU2IMPORT_FILE, wxID_WXFRAME1MENU2ITEMS1, 
 wxID_WXFRAME1MENU2ITEMS2, 
] = map(lambda _init_coll_menu2_Items: wxNewId(), range(3))

[wxID_WXFRAME1METERTYPEIMPORT_FILE, wxID_WXFRAME1METERTYPEITEMS1, 
 wxID_WXFRAME1METERTYPEITEMS2, 
] = map(lambda _init_coll_MeterType_Items: wxNewId(), range(3))

[wxID_WXFRAME1ACTIONEXPORT_TECPLOT, wxID_WXFRAME1ACTIONITEMS0, 
 wxID_WXFRAME1ACTIONITEMS1, wxID_WXFRAME1ACTIONITEMS2, 
 wxID_WXFRAME1ACTIONITEMS4, wxID_WXFRAME1ACTIONITEMS5, 
] = map(lambda _init_coll_Action_Items: wxNewId(), range(6))

[wxID_WXFRAME1SPCWINITEMS0, wxID_WXFRAME1SPCWINITEMS1, 
] = map(lambda _init_coll_Win_Items: wxNewId(), range(2))

[wxID_WXFRAME1STATISTICSITEMS1, wxID_WXFRAME1STATISTICSITEMS2, 
] = map(lambda _init_coll_Statistics_Items: wxNewId(), range(2))

class wxFrame1(wxFrame):
    def _init_coll_gridSizer1_Items(self, parent):
        # generated method, don't edit

        parent.AddWindow(self.Cancel, 1, border=0, flag=0)
        parent.AddWindow(self.TextField, 1, border=0, flag=0)
        parent.AddWindow(self.staticBox1, 1, border=0, flag=0)
        parent.AddWindow(self.staticBox2, 1, border=0, flag=0)
        parent.AddWindow(self.textCtrl1, 1, border=0, flag=0)
        parent.AddWindow(self.textCtrl2, 1, border=0, flag=0)
        parent.AddWindow(self.Stop, 1, border=0, flag=0)

    def _init_coll_Action_Items(self, parent):
        # generated method, don't edit

        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONITEMS0,
              item='Import File', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONITEMS1,
              item='Monitor File', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONITEMS2,
              item='Reread File', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONEXPORT_TECPLOT,
              item='Export Tecplot', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONITEMS4,
              item='Print Control Window', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1ACTIONITEMS5,
              item='Configuration File', kind=wxITEM_NORMAL)
        EVT_MENU(self, wxID_WXFRAME1ACTIONITEMS0, self.OnActionitems0Menu)
        EVT_MENU(self, wxID_WXFRAME1ACTIONITEMS1, self.OnActionitems1Menu)
        EVT_MENU(self, wxID_WXFRAME1ACTIONITEMS2, self.OnActionitems2Menu)
        EVT_MENU(self, wxID_WXFRAME1ACTIONEXPORT_TECPLOT,
              self.OnActionitems3Menu)
        EVT_MENU(self, wxID_WXFRAME1ACTIONITEMS4, self.OnActionitems4Menu)
        EVT_MENU(self, wxID_WXFRAME1ACTIONITEMS5, self.OnActionitems5Menu)

    def _init_coll_Statistics_Items(self, parent):
        # generated method, don't edit

        parent.Append(helpString='', id=wxID_WXFRAME1STATISTICSITEMS2,
              item='Process Statistics', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1STATISTICSITEMS1,
              item='Set Parameters', kind=wxITEM_NORMAL)
        EVT_MENU(self, wxID_WXFRAME1STATISTICSITEMS2,
              self.OnStatisticsitems2Menu)
        EVT_MENU(self, wxID_WXFRAME1STATISTICSITEMS1,
              self.OnStatisticsitems1Menu)

    def _init_coll_Win_Items(self, parent):
        # generated method, don't edit

        parent.Append(helpString='', id=wxID_WXFRAME1SPCWINITEMS0,
              item='Clear SPC Window', kind=wxITEM_NORMAL)
        parent.Append(helpString='', id=wxID_WXFRAME1SPCWINITEMS1,
              item='Clear Monitor Status Window', kind=wxITEM_NORMAL)
        EVT_MENU(self, wxID_WXFRAME1SPCWINITEMS0, self.OnWinitems0Menu)
        EVT_MENU(self, wxID_WXFRAME1SPCWINITEMS1, self.OnWinitems1Menu)

    def _init_coll_menuBar1_Menus(self, parent):
        # generated method, don't edit

        parent.Append(menu=self.Action, title='Action')
        parent.Append(menu=self.Statistics, title='Statistics')
        parent.Append(menu=self.Win, title='Window')

    def _init_sizers(self):
        # generated method, don't edit
        self.gridSizer1 = wxGridSizer(cols=0, hgap=0, rows=1, vgap=0)

        self._init_coll_gridSizer1_Items(self.gridSizer1)

    def _init_utils(self):
        # generated method, don't edit
        self.Action = wxMenu(title='Action')

        self.menuBar1 = wxMenuBar()
        self.menuBar1.SetBackgroundColour(wxColour(244, 244, 244))

        self.Statistics = wxMenu(title='Statistics')

        self.Win = wxMenu(title='Window')

        self._init_coll_Action_Items(self.Action)
        self._init_coll_menuBar1_Menus(self.menuBar1)
        self._init_coll_Statistics_Items(self.Statistics)
        self._init_coll_Win_Items(self.Win)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxFrame.__init__(self, id=wxID_WXFRAME1, name='', parent=prnt,
              pos=wxPoint(813, 262), size=wxSize(483, 666),
              style=wxDEFAULT_FRAME_STYLE, title='SPC')
        self._init_utils()
        self.SetClientSize(wxSize(475, 626))
        self.SetMenuBar(self.menuBar1)
        self.SetBackgroundColour(wxColour(212, 208, 200))

        self.textCtrl1 = wxTextCtrl(id=wxID_WXFRAME1TEXTCTRL1, name='textCtrl1',
              parent=self, pos=wxPoint(24, 16), size=wxSize(432, 24), style=0,
              value='')

        self.Stop = wxButton(id=wxID_WXFRAME1STOP, label='Stop', name='Stop',
              parent=self, pos=wxPoint(248, 544), size=wxSize(208, 32),
              style=0)
        EVT_BUTTON(self.Stop, wxID_WXFRAME1STOP, self.OnStopButton)

        self.TextField = wxTextCtrl(id=wxID_WXFRAME1TEXTFIELD, name='TextField',
              parent=self, pos=wxPoint(24, 80), size=wxSize(432, 184),
              style=wxTE_READONLY | wxTE_MULTILINE, value='')
        self.TextField.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              '@Arial Unicode MS'))
        self.TextField.Show(True)
        self.TextField.Enable(True)
        self.TextField.SetAutoLayout(False)
        self.TextField.SetForegroundColour(wxColour(37, 118, 252))

        self.staticBox1 = wxStaticBox(id=wxID_WXFRAME1STATICBOX1,
              label='Monitor Status Window', name='staticBox1', parent=self,
              pos=wxPoint(16, 48), size=wxSize(432, 232), style=0)

        self.Cancel = wxButton(id=wxID_WXFRAME1CANCEL, label='Cancel',
              name='Cancel', parent=self, pos=wxPoint(24, 544), size=wxSize(208,
              32), style=0)
        EVT_BUTTON(self.Cancel, wxID_WXFRAME1CANCEL, self.OnCancelButton)

        self.textCtrl2 = wxTextCtrl(id=wxID_WXFRAME1TEXTCTRL2, name='textCtrl2',
              parent=self, pos=wxPoint(24, 328), size=wxSize(432, 184),
              style=wxTE_READONLY | wxTE_MULTILINE, value='')
        self.textCtrl2.SetFont(wxFont(10, wxSWISS, wxNORMAL, wxNORMAL, False,
              '@Arial Unicode MS'))
        self.textCtrl2.SetForegroundColour(wxColour(251, 67, 47))

        self.staticBox2 = wxStaticBox(id=wxID_WXFRAME1STATICBOX2,
              label='Process Control Window', name='staticBox2', parent=self,
              pos=wxPoint(16, 296), size=wxSize(448, 232), style=0)

        self._init_sizers()

    def __init__(self, parent):
        self._init_ctrls(parent)        

        # Set up event handler for any worker thread results
        EVT_RESULT(self,self.OnResult)

        # And indicate we don't have a worker thread yet
        self.worker = None
        
        # create class for each meter type
        self.myMeter = []
        
        # set default path to pfile
        self.textCtrl1.SetValue(const_pfilePath)

    def OnResult(self, event):
        #update meter info from config file
        (const_mType,const_mIndexForward,
        const_mIndexReverse,UCLK,
        LCLK,UCLS,LCLS) = FillMeterTypeDictionary(self, const_configFilePath)
    
        if event.data is None:
            # Thread aborted (using our convention of None return)
            self.TextField.SetValue("Monitor aborted!\n%s" %self.TextField.GetValue())
            self.worker = None

        elif event.data == 1:
            #indicate monitor is in sleep mode
            self.TextField.SetValue("Monitor Sleeping...\n%s" %self.TextField.GetValue())   

        elif event.data == 2:
            #timer was disabled
            self.worker = None

            #check the file size
            self.TextField.SetValue("Monitor Checking File Size...\n%s" %self.TextField.GetValue())

            if CheckFile(self, self.textCtrl1.GetValue(), self.fileSize) == TRUE:
                self.TextField.SetValue("File Size Increased\n%s" %self.TextField.GetValue())
                #indicate file update

                self.TextField.SetValue("File is Reloading\n%s" %self.TextField.GetValue())
                #the function below should only update the meter data
                #however as a first try the below function will completely
                #reload the data

                self.myMeter = Reload(self, self.textCtrl1.GetValue())

                #indicate process control is being evaluated
                self.TextField.SetValue("Evaluating Process Control\n%s" %self.TextField.GetValue())            

                #check if process is in control
                badMeter = CheckProcess(self, self.myMeter)

                #indicate windows are being updated
                self.TextField.SetValue("Updating Process Control Window\n%s" %self.TextField.GetValue())                

                if badMeter == []:
                    #clear the field
                    self.textCtrl2.SetValue('')

                    #change to green
                    self.textCtrl2.SetForegroundColour(wxColour(7, 190, 12))
                    self.textCtrl2.SetValue('All Processes in Control')

                else:
                    #clear the field
                    self.textCtrl2.SetValue('')

                    #change to red
                    self.textCtrl2.SetForegroundColour(wxColour(251, 67, 47))

                    #print all bad meters                                        
                    for i in range(0, len(badMeter)):
                        self.textCtrl2.SetValue('%s Process Out of Control - %s \n%s' %(const_mType[const_mIndexReverse[badMeter[i][0]]],badMeter[i][1], self.textCtrl2.GetValue()))
                        
            #start sleeping agian
            if not self.worker and event.data != None:
                self.worker = WorkerThread(self)

    def OnStopButton(self, event):
        # Flag the worker thread to stop if running
        if self.worker:
            self.worker.abort()

            self.TextField.SetValue("Monitor Stopped\n%s" %self.TextField.GetValue())
        elif not self.worker:
            self.TextField.SetValue("No Monitor Available to Stop\n%s" %self.TextField.GetValue())

    def OnActionitems0Menu(self, event):
        dlg = wxFileDialog(self, "Choose a file", ".", "", "*.*", wxOPEN)
        try:
            if dlg.ShowModal() == wxID_OK:
                filename = dlg.GetPath()
                self.textCtrl1.SetValue(filename)
                const_pfilePath = filename
        finally:
            dlg.Destroy()

    #monitor button
    def OnActionitems1Menu(self, event):
        #get file size
        self.fileSize = int(stat(self.textCtrl1.GetValue())[6])
        # Trigger the worker thread unless it's already busy

        if not self.worker:            
            self.TextField.SetValue('Monitor Initiated\n%s' %self.TextField.GetValue())

            self.worker = WorkerThread(self)
        else:
            self.TextField.SetValue('Monitor Already Initiated\n%s' %self.TextField.GetValue())

    def OnActionitems2Menu(self, event):
        self.fileSize = int(stat(self.textCtrl1.GetValue())[6])
        #indicate file is loading
        self.TextField.SetValue("Reading Data... \n%s" %self.TextField.GetValue())
        #load the file
        self.myMeter = Reload(self, self.textCtrl1.GetValue())
        #indicate file has been loaded
        self.TextField.SetValue("Data Loaded\n%s" %self.TextField.GetValue())

    def OnCancelButton(self, event):
        self.Close()

    def OnPlotitems0Menu(self, event):
        event.Skip()

    def OnStatisticsitems2Menu(self, event):
        dlg = wxDialog1.wxDialog1(self)
        #dlg.myMeter = self.myMeter
        try: 
            dlg.ShowModal()
        finally:
            dlg.Destroy() 

    def OnWinitems0Menu(self, event):
        self.textCtrl2.SetValue('')

    def OnWinitems1Menu(self, event):
        self.TextField.SetValue('')

    def OnActionitems3Menu(self, event):
        #reload the file
        myMeter = Reload(self, self.textCtrl1.GetValue())
        
        #Send to Tecplot
        fileHandle  = file('Tecplot Out.dat', "w")
        
        #header
        fileHandle.write('TITLE = %s\n' %'"SeaMetrics SPC"')
        fileHandle.write('''VARIABLES = "Meter Factor (ppg)"\n"Sample"\n"Standard Deviation"\n
        "UCL Sigma K"\n"UCL Sigma S"\n"UCL 2 Sigma K"\n"UCL 2 Sigma S"\n"UCL 3 Sigma K"\n
        "UCL 3 Sigma S"\n"LCL Sigma K"\n"LCL Sigma S"\n"LCL 2 Sigma K"\n"LCL 2 Sigma S"\n
        "LCL 3 Sigma K"\n"LCL 3 Sigma S"\n''')
        
        #write the variables
        for i in range(0, len(const_mType)):
            sigmaK      = (1.0/3.0)*(UCLK[const_mType[const_mIndexReverse[i+1]]]-LCLK[const_mType[const_mIndexReverse[i+1]]])
            sigmaS      = (1.0/3.0)*(UCLS[const_mType[const_mIndexReverse[i+1]]]-LCLS[const_mType[const_mIndexReverse[i+1]]])
            KdoubleBar  = 0.5*(UCLK[const_mType[const_mIndexReverse[i+1]]]+LCLK[const_mType[const_mIndexReverse[i+1]]])
            Sbar        = 0.5*(UCLS[const_mType[const_mIndexReverse[i+1]]]+LCLS[const_mType[const_mIndexReverse[i+1]]])
            
            fileHandle.write('ZONE T="%s"\n' %const_mType[const_mIndexReverse[i+1]])
            fileHandle.write('I=%d, J=1\n' % (len(myMeter[i+1].kBar)))
            fileHandle.write('DATAPACKING=POINT DT=(SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE SINGLE)\n')
            for j in range(0, len(myMeter[i+1].kBar)):
                fileHandle.write('%f %d %f %f %f %f %f %f %f %f %f %f %f %f %f\n' % (myMeter[i+1].kBar[j], j, myMeter[i+1].stdev[j], KdoubleBar+sigmaK, Sbar+sigmaS, (KdoubleBar+2*sigmaK), (Sbar+2*sigmaS), (KdoubleBar+3*sigmaK), (Sbar+3*sigmaS), KdoubleBar-sigmaK, Sbar-sigmaS, (KdoubleBar-2*sigmaK), (Sbar-2*sigmaS), (KdoubleBar-3*sigmaK), (Sbar-3*sigmaS)))
        fileHandle.close()

    def OnStatisticsitems1Menu(self, event):
        dlg = wxDialog2.wxDialog2(self)
        #dlg.myMeter = self.myMeter
        try: 
            dlg.ShowModal()
        finally:
            dlg.Destroy() 

    def OnActionitems4Menu(self, event):
        data = wxPrintDialogData()
        data.EnablePrintToFile(true)
        data.EnablePageNumbers(true)
        data.EnableSelection(true)
        dlg = wxPrintDialog(self, data)
        try:
            if dlg.ShowModal() == wxID_OK:
                #do nothing
                pass
        finally:
            dlg.Destroy()

    def OnActionitems5Menu(self, event):        
        #launch dialog
        dlg = wxDialog3.wxDialog3(self)
        try: 
            dlg.ShowModal()
        finally:
            dlg.Destroy()
        
                    
                    

